/*	---
	antiAttach DbgUiRemoteBreakin 
	by ZaiRoN

	This is a simple plugin made just for fun. It's not a sort of professional 
	plugin (maybe you'll find bugs, you surely won't find checks on function's 
	return values and so on...); it was born in order to give you an idea on how 
	to fool the DbgUiRemoteBreakin anti attach trick. The trick is explained here: 
	http://www.kakeeware.com/i_antiattach.php
	The plugin has 2 voices:
	- Save bytes:						save part of the original DbgUiRemoteBreakin routine
	- antiAttach DbgUiRemoteBreakin:	restore part of the original DbgUiRemoteBreakin routine
	Obviously you have to save the bytes and then use the other voice :)
	---	*/

#include <windows.h>
#include <tlhelp32.h>
#include <string.h>
#include "plugin.h"

HINSTANCE hInst;
HWND hwmain;
HMODULE mhNtdll;
DWORD dbguiremotebreakinAdd;
DWORD rBytes;
char buffer[0x30] = {0};
char _DbgUiRemoteBreakin[0x30] = {0};
HANDLE hSnap;
PROCESSENTRY32 pEntry = {0}; 

/*	DllEntryPoint	*/
BOOL WINAPI DllEntryPoint(HINSTANCE hi,DWORD reason,LPVOID reserved)
{
	if (reason==DLL_PROCESS_ATTACH)
		hInst=hi;
	return 1;
}

/*	ODBG_Plugindata	*/
extc int _export cdecl ODBG_Plugindata(char shortname[32])
{
	strcpy(shortname,"antiAttach_DbgUiRemoteBreakin");
	return PLUGIN_VERSION;
}

/*	ODBG_Plugininit	*/
extc int _export cdecl ODBG_Plugininit(int ollydbgversion,HWND hw,ulong *features)
{
	//	Check that version of OllyDbg is correct.
	if (ollydbgversion<PLUGIN_VERSION)
		return -1;
	hwmain=hw;	// Keep handle of main OllyDbg window
	Addtolist(0,0,"antiAttach_DbgUiRemoteBreakin sample plugin, a not professional plugin made just for fun... by ZaiRoN");
	return 0;
}

/*	ODBG_Pluginmenu	*/
extc int _export cdecl ODBG_Pluginmenu(int origin,char data[4096],void *item)
{
	switch (origin)
	{
	case PM_MAIN:	
		//	Define the plugin menu items
		strcpy(data,"0 Save bytes,1 antiAttach DbgUiRemoteBreakin|2 &About");
		return 1;
	default: break;
	};
	return 0;
}

/*	ODBG_Pluginaction	*/
extc void _export cdecl ODBG_Pluginaction(int origin,int action,void *item)
{
	if (origin==PM_MAIN)
	{
		switch (action)
		{
		case 0:		//	Save bytes: take a copy of some bytes from DbgUiRemoteBreakin function
			mhNtdll = GetModuleHandle("ntdll.dll");
			dbguiremotebreakinAdd = (DWORD)GetProcAddress(mhNtdll, "DbgUiRemoteBreakin");
			memcpy(_DbgUiRemoteBreakin, dbguiremotebreakinAdd, 0x2F);
			break;
		case 1:		//	antiAttach DbgUiRemoteBreakin: restore original bytes and prevent anti-attach trick
			if (_DbgUiRemoteBreakin[0] == 0x00)
			{
				MessageBox(hwmain, "Save bytes first", "Attention!", MB_OK);
				break;
			}
			
			/*	The idea is to check all processes trying to find if there is -atleast- a process
				that use this trick. If a process is found the original bytes are restored.	*/
			hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); 
			pEntry.dwSize = sizeof(PROCESSENTRY32); 
			if (Process32First(hSnap, &pEntry)) 
			{ 
				do 
				{ 
					HANDLE hProcess; 
					hProcess = OpenProcess (PROCESS_ALL_ACCESS, FALSE, pEntry.th32ProcessID); 
					ReadProcessMemory(hProcess,dbguiremotebreakinAdd, buffer,0x2F,rBytes);
					if (memcmp(_DbgUiRemoteBreakin, buffer, 0x2F) != 0)
						//	Restore some bytes
						WriteProcessMemory(hProcess,dbguiremotebreakinAdd, _DbgUiRemoteBreakin, 0x2F,rBytes);
					CloseHandle (hProcess); 
				} 
				while (Process32Next(hSnap, &pEntry)); 
			} 
			CloseHandle (hSnap); 	
			MessageBox(hwmain, "Attach now", "OK",MB_OK);
			break;
		case 2:
			MessageBox(hwmain,
				"antiAttach_DbgUiRemoteBreakin sample plugin, a not professional plugin made just for fun...\nby ZaiRoN",
				"Info",
				MB_OK|MB_ICONINFORMATION);
			break;
		default: break;
		};
	}
}